SystemOrganization addCategory: #'DAO-SatelliteUI'!

WAComponent subclass: #DAOSatelliteControllerLauncher
	instanceVariableNames: 'controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!DAOSatelliteControllerLauncher class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/28/2013 16:21'!
newWithController: aSatelliteController

	^self new initializeWithController: aSatelliteController  ! !

!DAOSatelliteControllerLauncher methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/28/2013 16:23'!
initializeWithController: aSatelliteController

	controller := aSatelliteController 
! !

!DAOSatelliteControllerLauncher methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/1/2013 13:41'!
shutDown
	ZnZincServerAdaptor stop 

! !

!DAOSatelliteControllerLauncher methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/2/2013 17:05'!
startApp

	ZnZincServerAdaptor startOn: 8080.
	(WAAdmin register: SatelliteControlWebApp asApplicationAt: 'DAOSatelliteUI')
		addLibrary: PTDeploymentLibrary;
 	      addLibrary: SUDeploymentLibrary.
	! !

WAComponent subclass: #SatelliteControlWebComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

SatelliteControlWebComponent subclass: #CommandRequestUI
	instanceVariableNames: 'satelliteController subsystems subsystemName response commandsElementId commandParametersElementId commandSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!CommandRequestUI class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/2/2013 17:23'!
newWithController: aSatelliteController
	^ self new initializeWithController: aSatelliteController! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 11:34'!
children
	^ Array with: commandSelector.! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 18:35'!
commandWithName: aCommandName
	^ (commandSelector subsystem) commands at: aCommandName.! !

!CommandRequestUI methodsFor: 'initialization' stamp: 'EmilianoMenendez 11/10/2013 16:39'!
initialize
	super initialize.
	
	"children"
	commandSelector := CommandSelectorWithParameters new.
! !

!CommandRequestUI methodsFor: 'initialization' stamp: 'EmilianoMenendez 11/2/2013 17:04'!
initializeWithController: aSatelliteController 
	self initialize.
	satelliteController := aSatelliteController.	
	! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 16:45'!
renderContentOn: html
	| form |

	commandParametersElementId := html nextId.

	form := html form.
	form class: 'pure-form pure-form-aligned'.
	form with: [
		html fieldSet: [
			html legend: 'Send Command'.
			html render: commandSelector.
			html div class: 'pure-controls';				
				with: [ html submitButton class: 'pure-button pure-button-primary'; on: #sendCommand of: self. ].
		].
	].

	! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 18:34'!
sendCommand
	| command |
	
	command := self commandWithName: (commandSelector commandName).

	response := satelliteController sendCommand: command toSubsystem: (commandSelector subsystem) withData: (commandSelector data).
	
	self answer.! !

SatelliteControlWebComponent subclass: #CommandSelector
	instanceVariableNames: 'satelliteController subsystems subsystem commandName commandsElementId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!CommandSelector methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 18:19'!
commandName
	^ commandName! !

!CommandSelector methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 18:04'!
commandName: aCommandName
	commandName := aCommandName! !

!CommandSelector methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 18:51'!
commandNames
	| commandNames |

	commandNames := OrderedCollection new.
	commandNames add: 'All Commands'.
	commandNames addAll: self subsystem commands keys.

	^ commandNames.! !

!CommandSelector methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 19:08'!
commandWithName: aCommandName
	^ self subsystem commands at: aCommandName.! !

!CommandSelector methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 18:05'!
initialize
	super initialize.

	subsystems := OrderedCollection new.
	subsystems add: Subsystem thermal.
	subsystems add: Subsystem cdh.
	subsystems add: Subsystem memory.
	subsystems add: Subsystem platform.
	subsystems add: Subsystem power.
	
	self subsystem: subsystems first.
	self commandName: 'All Commands'.! !

!CommandSelector methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 18:04'!
renderCommandListOn: html
	"Used by Prototype to update the list of commands"	
      html label: 'Command: '.
	html select id: commandsElementId;
            list: self commandNames;
            selected: self commandName;
		callback: [:value | self commandName: value].
! !

!CommandSelector methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 17:12'!
renderContentOn: html
	| subsystemsElementId subsystemNames |
	
	subsystemsElementId := html nextId.
	commandsElementId := html nextId.
	
	subsystemNames := subsystems collect: [:aSubsystem | aSubsystem name ].

	html div class: 'pure-control-group inline'; 
		with: [ 
		      html label: 'Subsystem: '.
			html select
				id: subsystemsElementId;
		            list: subsystemNames;
		            selected:  self subsystem name;
				"update the list with ID commandListElementId, executing renderCommandListOn: ajaxHtml "
				onChange: (html scriptaculous updater 
					id: commandsElementId;
					triggerFormElement: subsystemsElementId;
	    	              callback: [ :ajaxHtml | self renderCommandListOn: ajaxHtml ]
				);
				"set the subsystem name posted by the form, then the variable subsystem will be used by renderCommandListOn: ajaxHtml to select the available commands for that subystem"			
				callback: [ :value | self subsystem: (self subsystemWithName: value). ].
		].
	html div class: 'pure-control-group'; id: commandsElementId;
		with: [ self renderCommandListOn: html ].
! !

!CommandSelector methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 11:19'!
subsystem
	^ subsystem ifNil: [ subsystems first. ]! !

!CommandSelector methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 13:32'!
subsystem: aSubsystem
	subsystem := aSubsystem! !

!CommandSelector methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 11:12'!
subsystemWithName: aSubsystemName
	^ subsystems detect: [ :each | each name = aSubsystemName ]! !

CommandSelector subclass: #CommandSelectorWithParameters
	instanceVariableNames: 'commandParametersElementId data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!CommandSelectorWithParameters methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 18:03'!
commandNames
	^ self subsystem commands keys.! !

!CommandSelectorWithParameters methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 17:57'!
data
	^ data ifNil: [ OrderedCollection new ].! !

!CommandSelectorWithParameters methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 19:15'!
initialize
	| command |
	
	super initialize.
	
	self commandName: (self subsystem commands keys at: 1).

"TODO uncomment when command list onChange AJAX callback is fixed"	
"	command := self subsystem commands at: (self commandName).

	data := command requestDefinition."
! !

!CommandSelectorWithParameters methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 19:05'!
renderCommandListOn: html
	"Used by Prototype to update the list of commands"
	
      html label: 'Command: '.
	html select
		id: commandsElementId;
            list: self commandNames;
            selected: self commandName;
		onChange: (html scriptaculous updater 
			id: commandParametersElementId;
			triggerFormElement: commandsElementId;
			callback: [ :ajaxHtml | self renderCommandParametersOn: ajaxHtml ]
		);
		callback: [:value | self commandName: value].
! !

!CommandSelectorWithParameters methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 16:13'!
renderCommandParameterListOn: html
	html label: 'Parameters: '.
	self commandDefinition requestDefinition do: [ :definition | 
		| parameterName | 
		parameterName := definition name.
		parameterName ifNil: [parameterName := ''].
		html label: parameterName.
		html textInput id: parameterName.
	].
! !

!CommandSelectorWithParameters methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 19:05'!
renderCommandParametersOn: html
	"Used by Prototype to update the list of commands"
	| commandParameters |
	
	commandParameters := self data.
	
	commandParameters do: [ :each |
		html text: each name.
		html textInput 
			callback: [ :value | each value: value  ];
			value: each value . 
		html space.
		 ]! !

!CommandSelectorWithParameters methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 17:58'!
renderContentOn: html
	commandParametersElementId := html nextId.

	super renderContentOn: html.

	html div class: 'pure-control-group';
		id: commandParametersElementId;
		with: [ self renderCommandParametersOn: html ].! !

SatelliteControlWebComponent subclass: #SatelliteControlView
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

SatelliteControlView subclass: #BeaconView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!BeaconView methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/28/2013 11:46'!
renderContentOn: html
	| subsystemName telemetryData |

	model data do: [ :telemetry |
		html definitionList: [ 
			subsystemName := telemetry key.
			html definitionTerm: subsystemName.
			telemetryData := telemetry value.
			telemetryData do: [ :data |
				html definitionData: data key, ':', data value printString.
			].
		].
	].! !

SatelliteControlView subclass: #CommandRequestView
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!CommandRequestView methodsFor: 'rendering' stamp: 'EmilianoMenendez 10/25/2013 11:59'!
renderContentOn: html
	model ifNotNil: [
		html label: 'Time: '.
		html text: model time printString.
		html break.
		html label: 'Subsystem: '.
		html text: model subsystem id.
		html break.
		html label: 'Command: '.
		html text: model commandId.
		html break.
		html label: 'Bytes: '.
		html text: bytes.
		html break.
	].! !

SatelliteControlView subclass: #CommandResponseView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!CommandResponseView methodsFor: 'rendering' stamp: 'EmilianoMenendez 10/26/2013 16:02'!
renderContentOn: html
	html label: 'Time: '.
	html text: self model time printString.
	html break.
	html label: 'Data: '.
	html break.
	self model data do: [ :data |
		html text: data key, ':', data value printString.
		html break.
	].
	html label: 'Bytes: '.
	html text: self model bytes.
	html break.! !

SatelliteControlView subclass: #ControllerLogEntryView
	instanceVariableNames: 'commandName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!ControllerLogEntryView methodsFor: 'rendering' stamp: 'EmilianoMenendez 11/4/2013 13:30'!
renderContentOn: html
	| requestView responseView |

	html tableRow: [ 
		html tableData: self model sequenceNumber.
		html tableData: self model commandName.
		requestView := CommandRequestView model: self model request.
		html tableData: requestView.
		responseView := self viewFor: model response.
		html tableData: responseView.
	].
! !

!ControllerLogEntryView methodsFor: 'rendering' stamp: 'EmilianoMenendez 11/4/2013 13:30'!
viewFor: aModel
	| beaconNames responseView |

	beaconNames := Array with: 'Beacon' with: 'ShortBeacon'.

	responseView := CommandResponseView model: aModel.
	
	(beaconNames includes: aModel commandName) ifTrue: [ responseView := BeaconView model: aModel ].
	
	^ responseView
! !

SatelliteControlView subclass: #ControllerLogFilterCriteriaView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!ControllerLogFilterCriteriaView methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 17:21'!
renderContentOn: html
	(self model isKindOf: SelectAllFilterCriteria) ifFalse: [ 
"		html aside: [ 
			html paragraph: 'Filter applied'.
		]."
		html paragraph: 'Filter applied.'.
	].
! !

SatelliteControlView subclass: #ControllerLogView
	instanceVariableNames: 'commandSelector filterCriteriaView filterCriteria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

ControllerLogView class
	instanceVariableNames: 'logFilter'!

ControllerLogView class
	instanceVariableNames: 'logFilter'!

!ControllerLogView class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 12:16'!
initializeWithModel: aLog
	super initializeWithModel: aLog.
	logFilter := ControllerLogFilter for: aLog.
! !

!ControllerLogView methodsFor: 'rendering' stamp: 'EmilianoMenendez 11/10/2013 12:14'!
children
	^ Array with: commandSelector.! !

!ControllerLogView methodsFor: 'filtering' stamp: 'EmilianoMenendez 11/10/2013 18:45'!
clearFilterCriteria
	filterCriteria := SelectAllFilterCriteria new.
	filterCriteriaView model: filterCriteria.! !

!ControllerLogView methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 18:26'!
commandWithName: aCommandName
	^ (commandSelector subsystem) commands at: aCommandName.! !

!ControllerLogView methodsFor: 'filtering' stamp: 'EmilianoMenendez 11/10/2013 18:56'!
filterCriteriaFor: aSubsystem and: aCommandName
	aCommandName = 'All Commands' ifTrue: [ ^ SubsystemFilterCriteria subsystem: aSubsystem].

	^ SubsystemAndCommandFilterCriteria subsystem: aSubsystem command: (self commandWithName: aCommandName).
! !

!ControllerLogView methodsFor: 'rendering' stamp: 'EzequielDavidovichCaballero 11/9/2013 22:01'!
filterLogWith: aCriteria
	 ^ model logFilter: aCriteria! !

!ControllerLogView methodsFor: 'initialization' stamp: 'EmilianoMenendez 11/10/2013 18:44'!
initialize
	super initialize.

	filterCriteria := SelectAllFilterCriteria new.

	"children"
	commandSelector := CommandSelector new.
	filterCriteriaView := ControllerLogFilterCriteriaView model: filterCriteria.
! !

!ControllerLogView methodsFor: 'model' stamp: 'EmilianoMenendez 11/10/2013 18:55'!
logEntries
	| log logFilter |
	
	log := self model.
	
	logFilter := ControllerLogFilter for: log.
	
	^ logFilter apply: filterCriteria.
! !

!ControllerLogView methodsFor: 'rendering' stamp: 'EmilianoMenendez 11/10/2013 17:36'!
renderContentOn: html
	| form table |
	
	form := html form.
	form class: 'pure-form pure-form-aligned'.
	form with: [
		html fieldSet: [
			html legend: 'Log'.
			html render: commandSelector.
			html div class: 'pure-controls'; with: [ 
				html submitButton class: 'pure-button pure-button-primary'; callback: [ self setFilterCriteria ]; with: 'Apply Filter'.
				html submitButton class: 'pure-button'; callback: [ self clearFilterCriteria ]; with: 'Clear'.
			].
			html render: filterCriteriaView.
		].
	].	
	
	table := html table.
	table class: 'pure-table pure-table-bordered'.
	table with: [
		html tableHead: [ 
			html tableRow: [ 
				html tableHeading: 'Sequence Number'.
				html tableHeading: 'Name'.
				html tableHeading: 'Request'.
				html tableHeading: 'Response'.
			].
		].
		self logEntries do: [ :logEntry | 
			html render: (ControllerLogEntryView model: logEntry).
		].
	].

! !

!ControllerLogView methodsFor: 'filtering' stamp: 'EmilianoMenendez 11/10/2013 18:44'!
setFilterCriteria
	filterCriteria := self filterCriteriaFor: (commandSelector subsystem) and: (commandSelector commandName).
	filterCriteriaView model: filterCriteria.! !

!SatelliteControlView class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/28/2013 11:11'!
model: aCommandResponseModel
	^ self new initializeWithModel: aCommandResponseModel.! !

!SatelliteControlView methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/28/2013 11:13'!
initializeWithModel: aModel
	super initialize.
	model := aModel.! !

!SatelliteControlView methodsFor: 'model' stamp: 'EmilianoMenendez 10/28/2013 11:11'!
model
	^ model! !

!SatelliteControlView methodsFor: 'model' stamp: 'EmilianoMenendez 11/10/2013 17:19'!
model: aModel
	model := aModel! !

SatelliteControlWebComponent subclass: #SatelliteControlWebApp
	instanceVariableNames: 'satelliteController commandRequestView controllerLogView commandRequestUi commandRequestForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!SatelliteControlWebApp class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 12:05'!
canBeRoot
	^ true! !

!SatelliteControlWebApp class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 12:26'!
initialize
	WAAdmin register: self asApplicationAt: 'satellitecontrol'! !

!SatelliteControlWebApp methodsFor: 'initialization' stamp: 'EmilianoMenendez 11/10/2013 16:37'!
children
	^ Array with: commandRequestForm with: controllerLogView.
! !

!SatelliteControlWebApp methodsFor: 'initialization' stamp: 'EmilianoMenendez 11/10/2013 16:37'!
initialize
	| satellite radio |
	
	super initialize.
	
"	satellite := SatelliteTest satelliteWithAllSubsystems.
	radio := SatelliteControllerRadioStub connectTo: satellite.
"
	radio := SatelliteControllerRadio connectTo: #[127 0 1 1] port: 4445.
	
	satelliteController := SatelliteController newWith: radio.

	satelliteController inspect.

	"children"
	commandRequestForm := CommandRequestUI newWithController: satelliteController.
	controllerLogView := ControllerLogView model: satelliteController log.! !

!SatelliteControlWebApp methodsFor: 'rendering' stamp: 'EmilianoMenendez 11/10/2013 17:26'!
renderContentOn: html
	html div class: 'content'; with: [
		html render: commandRequestForm.
		html render: controllerLogView.
	].
! !

!SatelliteControlWebComponent methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 17:31'!
style
 	^ '.command-form {background-color: cf5e0b} 
	   div.inline { float:left; }
	   .clearBoth { clear:both; }
	   .content { max-width: 1000px;} '! !

!SatelliteControlWebComponent methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/10/2013 13:00'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.

	anHtmlRoot stylesheet url: 'http://yui.yahooapis.com/pure/0.3.0/pure-min.css'.
	anHtmlRoot stylesheet url: 'http://purecss.io/combo/1.6.6?/css/main.css&/css/grids.css&/css/rainbow/baby-blue.css'.
! !
SatelliteControlWebApp initialize!
